/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Die Sobel-Klasse bedient sich zum Kanten finden der unten angegebenen 3x3-Gauß-Faltungsmatrizen
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

public class Sobel{
  
  
  private float[][] gMatrix1 = {{-1,   0,  1}, 
                               { -2,   0,  2}, 
                               { -1,   0,  1 }};  
                               
  private  float[][] gMatrix2 = {{-1,   -2,  -1}, 
                                {  0,    0,   0}, 
                                {  1,    2,   1 }};  
  
   private float rotAnteil, gruenAnteil, blauAnteil;
   private int[][] matrix;
  //Konstruktor
   public Sobel(int[][] matrix){
     this.matrix = matrix;
   }
   
/////////////////////////////////////////////////////////////////////
//Sobel-Filter auf Matrix eines Bildes anwenden
int[][] sobelAufMatrixAnwenden(){
   int[][]  bearbeitetMatrix =  matrix; 
  
  for(int k = 0; k < g; k++){ 
    for (int i = 0; i < w; i++) {   
      for (int j = 0; j < h; j++) {  
         float rotAnteil1   = 0.0, rotAnteil2   = 0.0;
         float gruenAnteil1 = 0.0, gruenAnteil2 = 0.0;
         float blauAnteil1  = 0.0, blauAnteil2  = 0.0 ; 
 
         for (int kx = -1; kx <= 1; kx++) {
             for (int ky = -1; ky <= 1; ky++) { //Anwendung der Faltungsmatrix bluf 7x7 
               if(i+kx<w && -1<i+kx && j+ky<h && -1<j+ky){
                color c = color(bearbeitetMatrix[i+kx][j+ky]);
                rotAnteil1   += red(c) *gMatrix1[kx+1][ky+1]*1.001 ; //1.001 gleicht die
                gruenAnteil1 += (green(c) * gMatrix1[kx+1][ky+1])*1.001;//subjektiv empfundene
                blauAnteil1  += (blue(c) * gMatrix1[kx+1][ky+1])*1.001; //Verdunkelung des Bildes aus
                rotAnteil2   += red(c) *gMatrix2[kx+1][ky+1]*1.001 ; //1.001 gleicht die
                gruenAnteil2 += (green(c) * gMatrix2[kx+1][ky+1])*1.001;//subjektiv empfundene
                blauAnteil2  += (blue(c) * gMatrix2[kx+1][ky+1])*1.001; //Verdunkelung des Bildes aus
                rotAnteil = abs(rotAnteil1+rotAnteil2);
                gruenAnteil = abs(gruenAnteil1+gruenAnteil2);
                blauAnteil = abs(blauAnteil1+blauAnteil2);
               }             
            }
        }
        float grauWert = (rotAnteil+gruenAnteil+blauAnteil)/3;
       
        grauWert = map(grauWert,0,255,255,0);//invertieren
        grauWert = grauWert*grauWert/255; //Kontrast erhöhen
        color farbe = color(grauWert);
        tempMatrix[i][j] = farbe; 
      }
   }
   for (int i = 0; i < w; i++) {
     for (int j = 0; j < h; j++) {
        bearbeitetMatrix[i][j] = (int)tempMatrix[i][j];
     }
   }   
  }
  return bearbeitetMatrix ; 
 }
      
}