/////////////////////////////////////////////////////////////////////////////////////////
//Die Klasse BlendingFilter überlagert die Matrizenrepräsentationen zweier Bilder
//Die zwei Bilder können auch - wie beim Beispiel des unscharf Maskierens - von 
//einem einzigen Bild kommen, wobei die Kopie des Bildes oftmals noch bearbeitet ist.
//Hier ist "Blending" am Beispiel der Subraktion, mit variablem "faktor" dargestellt
////////////////////////////////////////////////////////////////////////////////////
public class BlendingFilter{

 private int[][] matrix1, matrix2;
//Konstruktor 
 public BlendingFilter(int[][] matrix1, int[][] matrix2){
  this.matrix1 = matrix1;
  this.matrix2 = matrix2;
 }
////////////////////////////////////////////////////////////////////////////////////// 
//Blendingfunktion : Subtraktion
///////////////////////////////////////////////////////////////////////////////////
int[][] matrixBlending(){
  
  int spalten = matrix1.length;
  int zeilen = matrix1[0].length; 
  color c1,c2;
  float rot1   = 0.0;float gruen1 = 0.0; float blau1 = 0.0;  
  float rot2   = 0.0;float gruen2 = 0.0; float blau2= 0.0;
  float rot   = 0.0;float gruen = 0.0; float blau= 0.0;
  int[][] blendMatrix = new int[spalten][zeilen];println(faktor);
  for(int i=0; i<spalten;i++){
       for(int j=0; j<zeilen;j++){
           c1 = color(matrix1[i][j]);
           c2 = color(matrix2[i][j]);
           rot1=red(c1);gruen1=green(c1);blau1=blue(c1);
           rot2=red(c2);gruen2=green(c2);blau2=blue(c2);
           
           if(faktor*rot2-rot1>0){
             rot=faktor*rot2-rot1;
             rot =  constrain(rot, 0, 255);
           }else {rot=0;}
           
           if(faktor*gruen2-gruen1>0){
             gruen=faktor*gruen2-gruen1;
             gruen =  constrain(gruen, 0, 255);
           }else {gruen=0;}
           
           if(faktor*blau2-blau1>0){
             blau=faktor*blau2-blau1;
             blau =  constrain(blau, 0, 255);
           }else {blau=0;}
           blendMatrix[i][j] = color(rot,gruen,blau);
       }
   }
   return blendMatrix;
} 











}