/////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//Die Gauss-Klasse bedient sich zum Weichzeichnen der unten angegebenen 7x7-Gauß-Faltungsmatrix
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
public class Gauss{

 private float[][] gMatrix = {{0.00000067,   0.00002292,  0.00019117,   0.00038771,   0.00019117 ,  0.00002292,   0.00000067}, 
                             {0.00002292,   0.00078634 ,  0.00655965,   0.01330373,   0.00655965,   0.00078633 ,  0.00002292}, 
                             {0.00019117,   0.00655965 ,  0.05472157 , 0.11098164  , 0.05472157  , 0.00655965  , 0.00019117 },
                             {0.00038771 ,  0.01330373,   0.11098164,   0.22508352,   0.11098164,   0.01330373,   0.00038771},
                             {0.00019117,   0.00655965 ,  0.05472157 , 0.11098164  , 0.05472157  , 0.00655965  , 0.00019117 },
                             {0.00002292,   0.00078634 ,  0.00655965,   0.01330373,   0.00655965,   0.00078633 ,  0.00002292},
                             {0.00000067,   0.00002292,  0.00019117,   0.00038771,   0.00019117 ,  0.00002292,   0.00000067}};  

 private int[][] matrix;
//Konstruktor
 public Gauss(int[][] matrix){
   this.matrix = matrix;
 }
/////////////////////////////////////////////////////////////////////
//Gauß-Filter auf Matrix eines Bildes anwenden
int[][] gaussAufMatrixAnwenden(){
   int[][]  bearbeitetMatrix =  matrix; 
  
  for(int k = 0; k < g; k++){ 
    for (int i = 0; i < w; i++) {   
      for (int j = 0; j < h; j++) {  
         float rotAnteil   = 0.0;
         float gruenAnteil = 0.0;
         float blauAnteil  = 0.0; 
 
         for (int kx = -3; kx <= 3; kx++) {
             for (int ky = -3; ky <= 3; ky++) { //Anwendung der Faltungsmatrix bluf 7x7 
               if(i+kx<w && -1<i+kx && j+ky<h && -1<j+ky){
                color c = color(bearbeitetMatrix[i+kx][j+ky]);
                rotAnteil   += red(c) *gMatrix[kx+3][ky+3]*1.001 ; //1.001 gleicht die
                gruenAnteil += (green(c) * gMatrix[kx+3][ky+3])*1.001;//subjektiv empfundene
                blauAnteil  += (blue(c) * gMatrix[kx+3][ky+3])*1.001; //Verdunkelung des Bildes aus
               }             
            }
        }
        color farbe = color(rotAnteil,gruenAnteil,blauAnteil);
        tempMatrix[i][j] = farbe; 
      }
   }
   for (int i = 0; i < w; i++) {
     for (int j = 0; j < h; j++) {
        bearbeitetMatrix[i][j] = (int)tempMatrix[i][j];
     }
   }   
  }
  return bearbeitetMatrix ; 
 }
}